/***************************************************************************
****************************************************************************
****************************************************************************
*
* Clobberd - By Jason Nunn
* FREEWARE. Authorship Reserved 1996
*
* "A user regulator with attitude.." (ANSI C)
*
* Snail: 32 Rothdale Road, Moil, Darwin, NT, 0810, Australia
*
* ==================================================================
*
* Developed on a Linux 1.2.13 box ...then later 2.0.0
*
****************************************************************************
****************************************************************************
***************************************************************************/
#include "options.h"

#define VERSION  "2.9"
#define DATED    __DATE__
#define WELCOME \
"Welcome to Clobberd " VERSION ", Compiled: " DATED \
"\nby Jason Nunn. Authorship Reserved 1996\n" \
"Contact: 32 Rothdale Rd, Moil Darwin NT 0810, AUSTRALIA\n" \
"         jsno@stormfront.com.au,jsno@dayworld.net.au\n" \
"         http://dayworld.net.au/~jsno/\n\n"
#define STR_LEN       256
#define STR_EMAIL_LEN 36
#define STR_USER_LEN  (UT_NAMESIZE + 1)
#define CONFIG_FILE   "/etc/clobberd.cf." VERSION
#define DATA_FILE     "/etc/clobberd.db." VERSION
#define DIALINS_FILE  "/etc/ppp/dialins"

/*************************************************/
/** Structs **************************************/
/*************************************************/
#define EXEMPT_TTIME      0x01
#define EXEMPT_DTIME      0x02
#define EXEMPT_NICE       0x04
#define EXEMPT_CPU        0x08
#define EXEMPT_MEM        0x10
#define EXEMPT_CLOBBERING 0x20
#define INSTANT_PURGE_DT  0x40

#define DEFAULT_HR {0,60,3,SIGHUP,0,0,{-1,"",0,0,0,0,0,0}}

typedef struct
{
  uid_t  uid;
  char   email[STR_EMAIL_LEN];
  time_t total_time_limit;
  time_t daily_time_limit;
  int    nice_factor;
  int    cpu_limit;
  int    mem_limit;
  int    exempt;
} tusettings;

typedef struct
{
  int          run_level;
  unsigned int sleep_time;
  int          no_of_warnings;
  short        clobber_sig;
  short        min_free_dialins;
  int          def_usettings_enab;
  tusettings   def_usettings;
} tusettings_hr;

/*************************************************/
typedef struct
{
  int yesterday;
} tutmp_hr;

typedef struct
{
  char         user[STR_USER_LEN];
  uid_t        uid;
  pid_t        pid;
  char         active;
  time_t       total_time_used;
  time_t       daily_time_used;
  int          no_ttime_warnings;
  int          no_dtime_warnings;
  int          old_jiffies;
  int          jiffies;
  unsigned int rss;
  int          no_cpu_warnings;
  int          no_mem_warnings;
  float        nice_factor;
} tutmp;

typedef struct _tutmp_ll
{
  tutmp            *curr;
  struct _tutmp_ll *next;
} tutmp_ll;
