/***************************************************************************
****************************************************************************
****************************************************************************
*
* Clobberd - By Jason Nunn
* FREEWARE. Authorship Reserved 1996
*
* "A user regulator with attitude.." (ANSI C)
*
* Snail: 32 Rothdale Road, Moil, Darwin, NT, 0810, Australia
*
* ==================================================================
*
* Misc functions..
*
****************************************************************************
****************************************************************************
***************************************************************************/
#include <stdio.h>
#include <string.h>
#include <dirent.h>
#include <sys/stat.h>
#include <utmp.h>
#include "clobberd.h"

/***************************************************************************
*
***************************************************************************/
pid_t find_process(char *process_name,int mode)
{
  DIR *dp;
  struct dirent *dir_entry;
  pid_t proc_id = -1;

  if((dp = opendir("/proc")) != NULL)
  {
    while((dir_entry = readdir(dp)) != NULL)
    {
      int e_pid;

      if(sscanf(dir_entry->d_name,"%d",&e_pid))
      {
        FILE *fp;
        char str[STR_LEN];

        strcpy(str,"/proc/");
        strcat(str,dir_entry->d_name);
        strcat(str,"/stat");
        if((fp = fopen(str,"r")) != NULL)
        {
          char substr[STR_LEN];

          fgets(str,STR_LEN,fp);
          fclose(fp);
          if(sscanf(str,"%*u %s",substr))
          {
            if(!strcmp(substr,process_name))
              if(mode)
                proc_id = e_pid;
              else
                proc_id++;
          }
        }
      }
    }
    closedir(dp);
  }
  return proc_id;
}

/***************************************************************************
*
***************************************************************************/
void str_hh_mm(int t,char *s)
{
  char ms[4];

  if(t < 0) t = 0;
  t /= 60;
  sprintf(ms,"%d",(int)(t % 60));
  if(strlen(ms) == 1)
  {
    ms[1] = ms[0];
    ms[0] = '0';
    ms[2] = 0;
  }
  sprintf(s,"%d:%s",(int)(t / 60),ms);
}
